/**************************************************************************
 * SAMSUNG 11Mbps Wireless LAN PCMCIA device driver for Linux (swld11_cs).
 * 
 *  Header file : semmgmt_cs.c
 *
 * Copyright (c) 2000 SAMSUNG Electro-Mechanics CO.,Ltd. -- http://www.MagicLan.com
 * All rights reserved.
 *
 */

/* The following prevents "kernel_version" from being set in this file. */

#define __NO_VERSION__
#include <pcmcia/config.h>
#include <pcmcia/k_compat.h>

#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/ptrace.h>
#include <linux/malloc.h>
#include <linux/string.h>
#include <linux/timer.h>
#include <asm/io.h>
#include <asm/system.h>

#include <pcmcia/version.h>
#include <pcmcia/cs_types.h>
#include <pcmcia/cs.h>
#include <pcmcia/cistpl.h>
#include <pcmcia/cisreg.h>
#include <pcmcia/ds.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/skbuff.h>
#include <linux/if_arp.h>
#include <linux/ioport.h>
#include <linux/fcntl.h>


#include "swld11_cs.h"
#include "semdebug_cs.h"

WORD semGetIOPortWord(PSEM_ADAPTER Adapter,WORD port)
{
//  WORD value;

  return(IN_PORT_WORD(Adapter->IoBaseAddrR + port));
}

void semPutIOPortWord(PSEM_ADAPTER Adapter,WORD port,WORD value)
{

  OUT_PORT_WORD(Adapter->IoBaseAddrR + port,value);
}


WORD getInfoFrame(PSEM_ADAPTER Adapter,WORD InfoFID)
{
   WORD status,infoBuffer[100],Len; //wordValue;	
// int i;
   
//read the InfoTYPE.
	status = getFrame0(Adapter,InfoFID,infoBuffer,0,5);
	if(status != COMMAND_SUCCESS){
		return status;
	}

	if(infoBuffer[1] == COMMUNICATIONTALLIES){ //0xF100
/*	
	  Len = infoBuffer[0];
	  if(Len>100) Len = 100;
	  status = getFrame0(Adapter,InfoFID,infoBuffer,0,Len);

//	  Adapter->ptallies = (PTALLIES_INFO_STRUCT)&infoBuffer[2];
//	  Adapter->tallies = *(Adapter->ptallies);	
	  if(status != COMMAND_SUCCESS){
		return status;
	  }
*/	  	
/*	
	  DbgPrint("Communication Tallies..\n");
	
	 for(i=0;i<Len;++i)
	 	DEBUG(DEBUG_CALLTRACE,"%x ",infoBuffer[i]);
	 DEBUG(DEBUG_CALLTRACE,"\n");	
*/

	}
////////////////// LINK	status ////////////////////////////////////
	else if(infoBuffer[1] == LINKSTATUS){ //0xF200
		Adapter->LinkStatus = infoBuffer[2];	
		DEBUG(DEBUG_CALLTRACE,"Linkstatus : %x\n",infoBuffer[2]);
		}
	else if(infoBuffer[1] == SCANRESULTS){
	  Len = infoBuffer[0];
	  if(Len>500) Len = 490;
	  status = getFrame0(Adapter,InfoFID,(WORD*)Adapter->scan_buffer,0,(WORD)(Len+1));

//	  DEBUG(DEBUG_CALLTRACE,"Scan Result..\n");
	
//	 for(i=0;i<infoBuffer[0];++i)
//	 	DEBUG(DEBUG_CALLTRACE,"%x ",infoBuffer[i]);
//	 DEBUG(DEBUG_CALLTRACE,"\n");	
	}	
	else{
		DEBUG(DEBUG_CALLTRACE,"Unsupported InfoType %x\n",infoBuffer[1]);
	}

    return status;

}
WORD cardReset(PSEM_ADAPTER Adapter)
{
	WORD status,i;


       //disable interrupt.
	semPutIOPortWord(Adapter,INTEN,0);
	issueEventACK(Adapter,0xFFFF);

    Adapter->reclaimStatus = FALSE;
      //stop the card communication.
	status = Disable(Adapter);
	if(status !=COMMAND_SUCCESS){
	  DEBUG(DEBUG_CALLTRACE,"  cardRest: disable failed!\n");		
	  return(status);
	}

//initialize the statistic values
/*
	Adapter->Transmit = 0;	       //successed TX frame #
	Adapter->Receive  = 0;	       //successed RX frame #
	Adapter->TransmitErr = 0;      //failed	TX frame #
	Adapter->ReceiveErr = 0;       //failed	RX frame #
	Adapter->CurrentChannel= 1;
//    Adapter->PromiscuousMode = 0;
*/
	status = Initialize(Adapter);
	if(status != COMMAND_SUCCESS){
	  DEBUG(DEBUG_CALLTRACE,"Initialize() failed...\n");
	  return status;
	}

	status = cardInitialSet(Adapter);
	if(status != COMMAND_SUCCESS){
         DEBUG(DEBUG_CALLTRACE,"	 cardRest: cardInitialset Failed\n");
	 return(status);
	}
			
	cardStatusRead(Adapter);
	
    // commit the ALLOCATE command.
      for(i=0;i<10;++i){
       status = issueCmd1(Adapter,ALLOCATE,MAX_DATALEN+60);

        if(status != COMMAND_SUCCESS){
         DEBUG(DEBUG_CALLTRACE,"-->sendTxFrame: Coomand ALLOCATE Error,status = %x\n",status);
         issueEventACK(Adapter,ALLOCACK);
         if(i==10)
           return status;
        }
        else break;
       } //end of for statement....

       //wait until the ALLOC event is happened.
       for(i=0;i<10;++i){
         status = waitevent(Adapter,ALLOC);
         if(status == COMMAND_SUCCESS) break;
       }
       if(status != COMMAND_SUCCESS){
         //DEBUG(DEBUG_CALLTRACE,"-->sendTxFrame: event ALLOC Error,status = %x\n",result);
         //local->stats.tx_dropped++;
         return status;
       }

	   Adapter->FIDValue = semGetIOPortWord(Adapter,ALLOCFID); // read AllocFID IO PORT(22h).
       //issue ACK about ALLOC event.
       issueEventACK(Adapter,ALLOCACK);
       Adapter->reclaimStatus = TRUE;
     ////////////////////////////////////////////////////////////////////////////////////////////

    status = Enable(Adapter);
	if(status != COMMAND_SUCCESS){
  	   DEBUG(DEBUG_CALLTRACE,"  cardRest: Enable Failed\n");
	   return(status);
	}
			
	semPutIOPortWord(Adapter,INTEN,INFDROP|INFOEN|RXEN|ALLOCEN);

	return COMMAND_SUCCESS;

}
//---------------------------------------------------------------------------------
WORD getNetworkMode(PSEM_ADAPTER Adapter,WORD* value)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
	recordBuffer.RID       = CNFPORTTYPE;
	status = getRecordFrame(Adapter,pRecordBuffer);
	*value = recordBuffer.Data[0];

        DEBUG(DEBUG_CALLTRACE, " Network Mode = %x\n",*value);

	return status;

}
WORD setNetworkMode(PSEM_ADAPTER Adapter,WORD value)
{
    	WORD status,*pRecordBuffer;
    	Record_Buffer recordBuffer;

    	pRecordBuffer = (WORD*)&recordBuffer;

    	recordBuffer.RecordLen = 2;
    	recordBuffer.RID	   = CNFPORTTYPE;	
    	recordBuffer.Data[0]   = (BYTE)value;
    	recordBuffer.Data[1]   = 0x00;

    	status = putRecordFrame(Adapter,pRecordBuffer);

    	return status;
}

WORD getESSID(PSEM_ADAPTER Adapter,BYTE* byteString,WORD* Length)
{
	WORD status,*pRecordBuffer;
        BYTE i;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 18;
    	recordBuffer.RID	   = CNFDESIREDSSID;
    	status = getRecordFrame(Adapter,pRecordBuffer);

	*Length	= pRecordBuffer[2];
	if(*Length >32)	*Length	=32;
    	for(i=0;i<*Length;++i)
      	byteString[i] = recordBuffer.Data[i+2];
	byteString[*Length] = '\0';

        DEBUG(DEBUG_CALLTRACE, " Essid = %s\n",byteString);

	return status;
}
WORD setESSID(PSEM_ADAPTER Adapter,BYTE* byteString,WORD Length)
{
	WORD status,*pRecordBuffer;
    	BYTE i;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	if(((Adapter->Desired_ESSID[0] == 'A') || (Adapter->Desired_ESSID[0] ==	'a')) &&
		((Adapter->Desired_ESSID[1] == 'N') || (Adapter->Desired_ESSID[1] == 'n')) &&
		((Adapter->Desired_ESSID[2] == 'Y') || (Adapter->Desired_ESSID[2] == 'y')) ){
		if(Adapter->Desired_ESSID_Length == 3){
// this	case is	ANY ESSID.
	      recordBuffer.Data[0] = 0x00;
	      recordBuffer.Data[1] = 0x00;
	      for(i=0;i<32;++i)
		   recordBuffer.Data[i+2] =(BYTE)NULL;
		}
	}
	else{
	  recordBuffer.Data[0] = Adapter->Desired_ESSID_Length;
	  recordBuffer.Data[1] = 0x00;
	  for(i=0;i<Adapter->Desired_ESSID_Length;++i)
		recordBuffer.Data[i+2] = Adapter->Desired_ESSID[i];
	}
    	recordBuffer.RecordLen = 18;
    	recordBuffer.RID	   = CNFDESIREDSSID;	

    	status = putRecordFrame(Adapter,pRecordBuffer);

	return status;
}

WORD getSSID(PSEM_ADAPTER Adapter,BYTE*	byteString,WORD* Length)
{
	WORD status,*pRecordBuffer;
    	BYTE i;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 18;
    	recordBuffer.RID	   = CNFOWNSSID;
    	status = getRecordFrame(Adapter,pRecordBuffer);

	*Length	= pRecordBuffer[2];
	if(*Length >32)	*Length	=32;
	for(i=0;i<*Length;++i)
      	byteString[i] = recordBuffer.Data[i+2];
	byteString[*Length] = '\0';
		
        DEBUG(DEBUG_CALLTRACE, " ssid = %s\n",byteString);

	return status;
}

WORD setSSID(PSEM_ADAPTER Adapter,BYTE*	byteString,WORD	Length)
{
    	WORD status,*pRecordBuffer;
    	BYTE i;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.Data[0] = Adapter->Desired_ESSID_Length;
	recordBuffer.Data[1] = 0x00;
	for(i=0;i<Adapter->Desired_ESSID_Length;++i)
		recordBuffer.Data[i+2] = Adapter->Desired_ESSID[i];
		
	recordBuffer.RecordLen = 18;
    	recordBuffer.RID	   = CNFOWNSSID;	
    	status = putRecordFrame(Adapter,pRecordBuffer);

	return status;
}

WORD getChannel(PSEM_ADAPTER Adapter,WORD* value)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
        recordBuffer.RID	   = CNFOWNCHANNEL;
	status = getRecordFrame(Adapter,pRecordBuffer);
	*value = recordBuffer.Data[0];

        DEBUG(DEBUG_CALLTRACE, " Channel = %x\n",*value);
	return status;
}
WORD setChannel(PSEM_ADAPTER Adapter,WORD value)
{
    	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
    	recordBuffer.RID	   = CNFOWNCHANNEL;	
	recordBuffer.Data[0]   = (BYTE)value;
	recordBuffer.Data[1]   = 0x00;

    	status = putRecordFrame(Adapter,pRecordBuffer);

	return status;
}

WORD getAPDensity(PSEM_ADAPTER Adapter,WORD* value)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
    	recordBuffer.RID	   = CNFSYSTEMSCALE;
	status = getRecordFrame(Adapter,pRecordBuffer);
	*value = recordBuffer.Data[0];

        DEBUG(DEBUG_CALLTRACE, " AP Density = %x\n",*value);
	return status;
}
WORD setAPDensity(PSEM_ADAPTER Adapter,WORD value)
{
    	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
    	recordBuffer.RID	   = CNFSYSTEMSCALE;	
	recordBuffer.Data[0]   = (BYTE)value;
	recordBuffer.Data[1]   = 0x00;

    	status = putRecordFrame(Adapter,pRecordBuffer);
	return status;
}

//WORD getPwrMgmt(PSEM_ADAPTER Adapter,WORD* PSEnable,WORD* PSEnhance )
WORD getPwrMgmt(PSEM_ADAPTER Adapter,WORD* PSEnable)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
    	recordBuffer.RID	   = CNFPMENABLED;
	status = getRecordFrame(Adapter,pRecordBuffer);
	*PSEnable = recordBuffer.Data[0];
	
	DEBUG(DEBUG_CALLTRACE, " Power Enable = %x\n",*PSEnable);

/*
	recordBuffer.RecordLen = 2;
        recordBuffer.RID	   = CNFPMENABLED;
	status = getRecordFrame(Adapter,pRecordBuffer);
	*PSEnhance = recordBuffer.Data[0];
	
        DEBUG(DEBUG_CALLTRACE, "	Power Enhance =	%x\n",*PSEnhance);

*/
	return status;
}

WORD getPwrMgmtEnhance(PSEM_ADAPTER Adapter,WORD* PSEnhance)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
        recordBuffer.RID	   = CNFPMEPS;
	status = getRecordFrame(Adapter,pRecordBuffer);
	*PSEnhance = recordBuffer.Data[0];
	
        DEBUG(DEBUG_CALLTRACE, " Power Enhance = %x\n",*PSEnhance);

	return status;
}

WORD setPwrMgmt(PSEM_ADAPTER Adapter,WORD PSEnable)//,WORD	PSEnhance )
// PSEnable  : 0 - Disable, 1 -	Enable
// PSEnhance : 0 - Normal,  1 -	Enhance
//
{
    	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

//Power	Management Enable/Disable
    	recordBuffer.RecordLen = 2;
    	recordBuffer.RID	   = CNFPMENABLED;	
	recordBuffer.Data[0]   = (BYTE)PSEnable;
	recordBuffer.Data[1]   = 0x00;

	status = putRecordFrame(Adapter,pRecordBuffer);
/*	
//Power	Enhance	
	recordBuffer.RecordLen = 2;
    	recordBuffer.RID	   = CNFPMEPS;	
	recordBuffer.Data[0]   = (BYTE)PSEnhance;
	recordBuffer.Data[1]   = 0x00;

	status = putRecordFrame(Adapter,pRecordBuffer);
*/	
	return status;
}

WORD getStationName(PSEM_ADAPTER Adapter,BYTE* byteString,WORD*	Length)
{
	WORD status,*pRecordBuffer;
    	BYTE i;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 18;
    	recordBuffer.RID	   = CNFOWNNAME;
    	status = getRecordFrame(Adapter,pRecordBuffer);

	*Length	= pRecordBuffer[2];
	if(*Length >32)	*Length	=32;
	for(i=0;i<*Length;++i)
      	byteString[i] = recordBuffer.Data[i+2];
	byteString[*Length] = '\0';

	DEBUG(DEBUG_CALLTRACE, " OWN Name = %s\n",byteString);

	return status;
}
WORD setStationName(PSEM_ADAPTER Adapter,BYTE* byteString,WORD Length)
{
    	WORD status,*pRecordBuffer;
    	BYTE i;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.Data[0] = (BYTE)Length;
	recordBuffer.Data[1] = 0x00;
	for(i=0;i<Length;++i)
		recordBuffer.Data[i+2] = byteString[i];
	recordBuffer.RecordLen = 18;
    	recordBuffer.RID	   = CNFOWNNAME;	
    	status = putRecordFrame(Adapter,pRecordBuffer);
    	return status;
}

WORD getRTSThreshold(PSEM_ADAPTER Adapter,WORD*	value)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
        recordBuffer.RID	   = RTSTHRESHOLD;
	status = getRecordFrame(Adapter,pRecordBuffer);
	*value = pRecordBuffer[2];
	
        DEBUG(DEBUG_CALLTRACE, " RTS Threshold = %x\n",*value);

	return status;
}
WORD setRTSThreshold(PSEM_ADAPTER Adapter,WORD value)
{
        WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
        recordBuffer.RID	   = RTSTHRESHOLD;	
	pRecordBuffer[2]       = value;

	status = putRecordFrame(Adapter,pRecordBuffer);
	return status;
}

WORD getFragmentationThreshold(PSEM_ADAPTER Adapter,WORD* value)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
        recordBuffer.RID	   = FRAGMENTATIONTHRESHOLD;
	status = getRecordFrame(Adapter,pRecordBuffer);
	*value = pRecordBuffer[2];
	
        DEBUG(DEBUG_CALLTRACE, " Fragmentation Threshold = %x\n",*value);

	return status;
}
WORD setFragmentationThreshold(PSEM_ADAPTER Adapter,WORD value)
{
        WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
        recordBuffer.RID	   = FRAGMENTATIONTHRESHOLD;	
	pRecordBuffer[2]       = value;

	status = putRecordFrame(Adapter,pRecordBuffer);
	return status;
}

WORD getTxRate(PSEM_ADAPTER Adapter,WORD* value)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
    recordBuffer.RID	   = TXRATECONTROL;
	status = getRecordFrame(Adapter,pRecordBuffer);
	*value = recordBuffer.Data[0];

       DEBUG(DEBUG_CALLTRACE, " Tx Rate Control = %x\n",recordBuffer.Data[0]);

	return status;
}
WORD setTxRate(PSEM_ADAPTER Adapter,WORD value)
{
        WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
    	recordBuffer.RID	   = TXRATECONTROL;	
	pRecordBuffer[2]  = (WORD)value;
	
	status = putRecordFrame(Adapter,pRecordBuffer);
	return status;
	
}
//---------------------	Current	MAC status -------------------------------
WORD getCurrentESSID(PSEM_ADAPTER Adapter,BYTE*	byteString,WORD* Length)
{
	WORD status,*pRecordBuffer;
    	BYTE i;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 18;
	recordBuffer.RID = CURRENTSSID;
    	status = getRecordFrame(Adapter,pRecordBuffer);

	*Length	= pRecordBuffer[2];
	if(*Length >32)	*Length	=32;
        for(i=0;i<*Length;++i)
           byteString[i] = recordBuffer.Data[i+2];
	byteString[*Length] = '\0';

//      DEBUG(DEBUG_CALLTRACE, "  Current Essid	= %s\n",byteString);

	return status;
}

WORD getPortstatus(PSEM_ADAPTER	Adapter,WORD* value)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

//Portstatus - Current MAC port	Connection status;
	recordBuffer.RecordLen = 2;
    recordBuffer.RID	   = PORTSTATUS;
	status = getRecordFrame(Adapter,pRecordBuffer);
	*value = recordBuffer.Data[0];
	
        DEBUG(DEBUG_CALLTRACE, " Port status  = %x\n",*value);

	return status;
}

WORD getCurrentBSSID(PSEM_ADAPTER Adapter,BYTE*	byteString)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;
	BYTE i;

	pRecordBuffer =	(WORD*)&recordBuffer;

    	recordBuffer.RecordLen = 4;
    	recordBuffer.RID	   = CURRENTBSSID;	//0xFD42
	status = getRecordFrame(Adapter,pRecordBuffer);
	if(status == COMMAND_SUCCESS){
    	for(i=0;i<SEM_LENGTH_OF_ADDRESS;++i)
		   byteString[i] = recordBuffer.Data[i];
	}
	else
		for(i=0;i<SEM_LENGTH_OF_ADDRESS;++i)
		   byteString[i] = 0xFF;

//      DEBUG(DEBUG_CALLTRACE, "  Current BSSID	= %s\n",byteString);

		return status;
}

WORD getCommsQuality(PSEM_ADAPTER Adapter,WORD*	wordString)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;
	BYTE i;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 4;
  recordBuffer.RID	   = COMMSQUALITY;
	status = getRecordFrame(Adapter,pRecordBuffer);
  for(i=0;i<3;++i)
	  wordString[i]	= pRecordBuffer[i+2];  // CQ,ASL,ANL

 //DEBUG(DEBUG_CALLTRACE, "CQ = %x, ASL = %x\n",wordString[0],wordString[1]);

   	return status;
}

WORD getCurrentChannel(PSEM_ADAPTER Adapter,WORD* value)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
    	recordBuffer.RID	   = CURRENTCHANNEL;
	status = getRecordFrame(Adapter,pRecordBuffer);
	*value = pRecordBuffer[2];

//     DEBUG(DEBUG_CALLTRACE, "	Current	Channel	= %x\n",*value);

	return status;
}

WORD getCurrentTxRate(PSEM_ADAPTER Adapter,WORD* value)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
    	recordBuffer.RID	   = CURRENTTXRATE;
	status = getRecordFrame(Adapter,pRecordBuffer);
	*value = pRecordBuffer[2];

      DEBUG(DEBUG_CALLTRACE, "Current Tx Rate = %x\n",pRecordBuffer[2]);

	return status;
}

WORD getCurrentPwrState(PSEM_ADAPTER Adapter,WORD* value)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
	recordBuffer.RID       = CURRENTPOWERSTATE;
	status = getRecordFrame(Adapter,pRecordBuffer);
	*value = pRecordBuffer[2];

        DEBUG(DEBUG_CALLTRACE, " Current	Pwr State = %x\n",*value);

	return status;
}

WORD getShortPreamble(PSEM_ADAPTER Adapter,WORD* value)
{
	WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
        recordBuffer.RID       = cnfShortPreamble;
	status = getRecordFrame(Adapter,pRecordBuffer);
	*value = pRecordBuffer[2];
	
        DEBUG(DEBUG_CALLTRACE," ShortPReamble = %x\n",*value);

	return status;
}

WORD setShortPreamble(PSEM_ADAPTER Adapter,WORD value)
{
        WORD status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 2;
        recordBuffer.RID       = cnfShortPreamble;	
	pRecordBuffer[2]       = value;

	status = putRecordFrame(Adapter,pRecordBuffer);
	return status;
}

WORD getAuthentication(PSEM_ADAPTER Adapter,WORD* value)
{
	WORD Status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 4;
     recordBuffer.RID	   = CNFAUTHENTICATION;
	Status = getRecordFrame(Adapter,pRecordBuffer);
	*value = recordBuffer.Data[0];

     DEBUG(DEBUG_CALLTRACE," Authentication = %x\n",*value);
	return Status;
}

WORD setAuthentication(PSEM_ADAPTER Adapter,WORD value)
{
     WORD Status,*pRecordBuffer;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

	recordBuffer.RecordLen = 4;
     recordBuffer.RID	   = CNFAUTHENTICATION;	
	pRecordBuffer[2]  =  value;
	
	Status = putRecordFrame(Adapter,pRecordBuffer);
	return Status;
	
}
WORD cardStatusRead(PSEM_ADAPTER Adapter)
{
       	WORD status,wordTemp,*pRecordBuffer,Length;
        BYTE byteString[34];
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

//+++Network Mode
    	getNetworkMode(Adapter,&wordTemp);

//+++ESSID
	getESSID(Adapter,byteString,&Length);
//+++ SSID
    	getSSID(Adapter,byteString,&Length);

//+++ Channel
    	getChannel(Adapter,&wordTemp);

//+++ AP Density
    	getAPDensity(Adapter,&wordTemp);

//+++Power mgmt
     getPwrMgmt(Adapter,&wordTemp);
     //getPwrMgmtEnhance(Adapter,&wordTemp);
	
//+++ Station Name
    	getStationName(Adapter,byteString,&Length);

//   Fragmentaion
     getFragmentationThreshold(Adapter,&wordTemp);

//+++RTS Threshold
	getRTSThreshold(Adapter,&wordTemp);

//+++ Tx Rate control
    	getTxRate(Adapter,&wordTemp);

//SEM 10/20/99 ver2.1 for supporting WEP.

//read WEP default Key ID.
   	getWEPDefaultKeyID(Adapter,&wordTemp);

//read WEP Flags.
   	getWEPFlags(Adapter,&wordTemp);
     DEBUG(DEBUG_CALLTRACE,"  WEP Flag = %d\n",wordTemp&0x0f);
//read Suthentication TYpe.
   	getAuthentication(Adapter,&wordTemp);

//read the condition for Preamble.
   	getShortPreamble(Adapter,&wordTemp);

//Get Allowed regulatory Domains.
	recordBuffer.RecordLen = 5;
     recordBuffer.RID       = REGULATORYDOMAINS;	
	status = getRecordFrame(Adapter,pRecordBuffer);
	
	if(status != COMMAND_SUCCESS)
	   Adapter->CurrentRegDomain = 0x30;     // default setting as ETSI	
	else
	   Adapter->CurrentRegDomain  = recordBuffer.Data[2];
	
	DEBUG(DEBUG_CALLTRACE, "  Current Regulatory Domain = %x,%x,%x,%x\n",  recordBuffer.Data[0],
	    recordBuffer.Data[1],recordBuffer.Data[2],recordBuffer.Data[3]);

       if(Adapter->CurrentRegDomain == FCC){
          if(Adapter->Channel >11) Adapter->Channel =1;
       }
       else if(Adapter->CurrentRegDomain == ETSI){
          if(Adapter->Channel >13) Adapter->Channel =1;
       }
       else if(Adapter->CurrentRegDomain == SPAIN){
         if((Adapter->Channel <10) || (Adapter->Channel>11)) Adapter->Channel =10;
       }
       else if(Adapter->CurrentRegDomain == FRANCE){
          if((Adapter->Channel <10) || (Adapter->Channel>13)) Adapter->Channel =10;
       }

       DEBUG(DEBUG_CALLTRACE,"   Channel = %d,Domain=%x\n",Adapter->Channel,Adapter->CurrentRegDomain);	

//+++ Tick Time

	recordBuffer.RecordLen = 2;
        recordBuffer.RID	   = TICKTIME;
	status = getRecordFrame(Adapter,pRecordBuffer);
	wordTemp = pRecordBuffer[2];

        DEBUG(DEBUG_CALLTRACE, " Tick Time = %x\n",wordTemp);

        return COMMAND_SUCCESS;	
}	


WORD cardInitialSet(PSEM_ADAPTER Adapter)
/*++
Routine	Description:
   it makes 3841 MAC Controller into enable state.

Arguments:
 Adapter - Host	main data structure Variable.

Return Value:
  COMMAND_SUCCESS -	Command	is commpleted successfully.
  COMMAND_FAILURE - failed.
--*/
{
        WORD status,*pRecordBuffer;
	BYTE i;
	Record_Buffer recordBuffer;

	pRecordBuffer =	(WORD*)&recordBuffer;

//-------------- Static	Configuration Entities.	---------------------------------
//+++ read Network Address.
   recordBuffer.RecordLen = 4;
   recordBuffer.RID	  = CNFOWNMACADDRESS;	
   status = getRecordFrame(Adapter,pRecordBuffer);
    if(status == COMMAND_SUCCESS){
		for(i=0;i<SEM_LENGTH_OF_ADDRESS;++i)
		 Adapter->NetworkAddress[i] = recordBuffer.Data[i];
		
	 DEBUG(DEBUG_CALLTRACE, "SEM--> Network IEEE addr(original) %x %x %x %x %x %x\n",Adapter->NetworkAddress[0],
			 Adapter->NetworkAddress[1],Adapter->NetworkAddress[2],
		         Adapter->NetworkAddress[3],Adapter->NetworkAddress[4],
			 Adapter->NetworkAddress[5]);

	}
	else{
         DEBUG(DEBUG_CALLTRACE,"Error read Record	type = %x\n",CNFOWNMACADDRESS);

	}

//Read the Network Addres(MAC ID) from Choice MAC Record.

    if((Adapter->CurrentNetworkAddress[0] == 0x00) &&
		(Adapter->CurrentNetworkAddress[1] == 0x00) &&
		(Adapter->CurrentNetworkAddress[2] == 0x00) &&
		(Adapter->CurrentNetworkAddress[3] == 0x00) &&
		(Adapter->CurrentNetworkAddress[4] == 0x00) &&
		(Adapter->CurrentNetworkAddress[5] == 0x00))
	{
		for(i=0;i<6;++i)
			Adapter->CurrentNetworkAddress[i] = Adapter->NetworkAddress[i];
	}
// Write Network Address.

    else{   // user already define the MAC ID. so write	the mac	id into	CW10.
       recordBuffer.RecordLen =	4;
       recordBuffer.RID	      =	CNFOWNMACADDRESS;
       for(i=0;i<6;++i)
       recordBuffer.Data[i] = Adapter->CurrentNetworkAddress[i];

       status =	putRecordFrame(Adapter,pRecordBuffer);
    if(status != COMMAND_SUCCESS){
    	DEBUG(DEBUG_CALLTRACE, "Error Write Record type =	%x\n",CNFOWNMACADDRESS);
	  }

     DEBUG(DEBUG_CALLTRACE, "SEM--> Network IEEE addr(changed) %x %x %x %x	%x %x\n",Adapter->CurrentNetworkAddress[0],
			 Adapter->CurrentNetworkAddress[1],Adapter->CurrentNetworkAddress[2],
		         Adapter->CurrentNetworkAddress[3],Adapter->CurrentNetworkAddress[4],
			 Adapter->CurrentNetworkAddress[5]);	
	 }

  for(i=0;i<SEM_LENGTH_OF_ADDRESS;++i)
	  Adapter->CurrentBSSID[i] = 0xFF; // Broadcasting Address.

//++ Write the Network Mode
    status = setNetworkMode(Adapter,(WORD)Adapter->NetworkMode);
	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE, "Set Network Mode failure.\n");
	}

//++ Write Current ESSID(FC02) <- Infrastructure mode
   status = setESSID(Adapter,Adapter->Desired_ESSID,(WORD)Adapter->Desired_ESSID_Length);
	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE, "Set ESSID failure.\n");
	}

//++ Write Current SSID(FC04) <- Ad_Hoc	Mode.
   status = setSSID(Adapter,Adapter->Desired_ESSID,(WORD)Adapter->Desired_ESSID_Length);

	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE, "Set ESSID failure.\n");
	}

//++ Channel(FC03)
    status = setChannel(Adapter,(WORD)Adapter->Channel);

	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE, "Set Channel failure.\n");
	}

//+++ AP Density(FC03)
	status = setAPDensity(Adapter,(WORD)Adapter->APDensity);

	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE, "Set AP Density failure.\n");
	}

// Power Mgmt Enable/Disable.
	status = setPwrMgmt(Adapter,(WORD)Adapter->PSModeValue);//,(WORD)Adapter->PSLevel);

	if(status != COMMAND_SUCCESS){
		 DEBUG(DEBUG_CALLTRACE, "Set PowerSAving failure.\n");
	}

// Own Name
	status = setStationName(Adapter,Adapter->StationName,(WORD)Adapter->StationNameLength);

	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE,"Set OWN NAME failure.\n");
	}
	
//SEM 10/20/99 ver2.1 for supporting WEP.
//set WEP Flags.

   status = setWEPFlags(Adapter,(WORD)(Adapter->WepRequired & 0x03));
   if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE,"Set WEP Flags failure.\n");
   }

//set WEP default Key ID.
   if(Adapter->WepRequired == WEP_128BIT)
       Adapter->WepDefaultKeyId = 0;	
   status = setWEPDefaultKeyID(Adapter,(WORD)Adapter->WepDefaultKeyId);
   	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE,"Set WEP Default KEY ID failure.\n");
	}
//set WEP Default Key 0,1,2,3
   if(Adapter->WepRequired == WEP_128BIT){
    status = setWEPDefaultKey0(Adapter,Adapter->WepDefaultKey0);
   	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE,"Set WEP Default KEY0 failure.\n");
	}
/*
     DEBUG(DEBUG_CALLTRACE,"   Key0= %x,%x,%x,%x,%x,%x,%x,%x,%x,%x,%x,%x,%x,%x\n",
							Adapter->WepDefaultKey0[0],Adapter->WepDefaultKey0[1],
                                   Adapter->WepDefaultKey0[2],Adapter->WepDefaultKey0[3],Adapter->WepDefaultKey0[4],
                                   Adapter->WepDefaultKey0[5],Adapter->WepDefaultKey0[6],Adapter->WepDefaultKey0[7],
							Adapter->WepDefaultKey0[8],Adapter->WepDefaultKey0[9],Adapter->WepDefaultKey0[10],
							Adapter->WepDefaultKey0[11],Adapter->WepDefaultKey0[12],Adapter->WepDefaultKey0[13]);
*/
   }
   else{
    status = setWEPDefaultKey0(Adapter,Adapter->WepDefaultKey0);
   	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE,"Set WEP Default KEY0 failure.\n");
	}
   status = setWEPDefaultKey1(Adapter,Adapter->WepDefaultKey1);
   	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE,"Set WEP Default KEY1 failure.\n");
	}
   status = setWEPDefaultKey2(Adapter,Adapter->WepDefaultKey2);
   	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE,"Set WEP Default KEY2 failure.\n");
	}
   status = setWEPDefaultKey3(Adapter,Adapter->WepDefaultKey3);
   	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE,"Set WEP Default KEY3 failure.\n");
	}
    }
/*	
   DEBUG(DEBUG_CALLTRACE,"   Key ID = %d\n",Adapter->WepDefaultKeyId);
   DEBUG(DEBUG_CALLTRACE,"   Key0= %x,%x,%x,%x,%x,%x\n",Adapter->WepDefaultKey0[0],Adapter->WepDefaultKey0[1],
                             Adapter->WepDefaultKey0[2],Adapter->WepDefaultKey0[3],Adapter->WepDefaultKey0[4],
                             Adapter->WepDefaultKey0[5]);
   DEBUG(DEBUG_CALLTRACE,"   Key1= %x,%x,%x,%x,%x,%x\n",Adapter->WepDefaultKey1[0],Adapter->WepDefaultKey1[1],
                             Adapter->WepDefaultKey1[2],Adapter->WepDefaultKey1[3],Adapter->WepDefaultKey1[4],
                             Adapter->WepDefaultKey1[5]);
   DEBUG(DEBUG_CALLTRACE,"   Key2= %x,%x,%x,%x,%x,%x\n",Adapter->WepDefaultKey2[0],Adapter->WepDefaultKey2[1],
                             Adapter->WepDefaultKey2[2],Adapter->WepDefaultKey2[3],Adapter->WepDefaultKey2[4],
                             Adapter->WepDefaultKey2[5]);
   DEBUG(DEBUG_CALLTRACE,"   Key3= %x,%x,%x,%x,%x,%x\n",Adapter->WepDefaultKey3[0],Adapter->WepDefaultKey3[1],
                             Adapter->WepDefaultKey3[2],Adapter->WepDefaultKey3[3],Adapter->WepDefaultKey3[4],
                             Adapter->WepDefaultKey3[5]);
*/
//read Authentication TYpe.
  if((Adapter->WepRequired & 0x03) == 3){ // Mandatory..
//for supporting the OPEN System Method on the WEP.
	status = setAuthentication(Adapter,Adapter->AuthenticationType);
//	
    if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE,"Set Authentication TYPE failure.\n");
	}
  }

//end of sem

// -------------Dynamic	Configuration Entities --------------------------------
//for supporting Fragmentation Threshold
	status = setFragmentationThreshold(Adapter,(WORD)Adapter->FragThresh);

	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE,"Set Fragmentation Threshold failure.\n");
	}
//++++ RTSThreshold
	status = setRTSThreshold(Adapter,(WORD)Adapter->Threshold);

	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE,"Set RTSThreshold failure.\n");
	}

//++++ TxRateControl
	status = setTxRate(Adapter,(WORD)Adapter->TransmitRate);

	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE,"Set Tx Rate Control failure.\n");
	}

//for controling the Preamble.
     status = setShortPreamble(Adapter,1);//Adapter->ShortPreamble);
	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE,"Set as ShortPreamble failure.\n");
    }

 //Tick	Time
	recordBuffer.RecordLen = 2;
    	recordBuffer.RID	   = TICKTIME;	
	pRecordBuffer[2]       = 0;

	status = putRecordFrame(Adapter,pRecordBuffer);
	if(status != COMMAND_SUCCESS){
		DEBUG(DEBUG_CALLTRACE,"Set Tick Time	failure.\n");
	}
	
//--------------------- READ Information RECORD ------------------------
//----------------------------------------------------------------------

//Get Download buffer location and size (0xFD01)
/*
	recordBuffer.RecordLen = 4;
    	recordBuffer.RID       = DOWNLOADBUFFER;	
	status = getRecordFrame(Adapter,pRecordBuffer);
	Adapter->dlPage = pRecordBuffer[2];
	Adapter->dlOffset = pRecordBuffer[3];
	Adapter->dlLength = pRecordBuffer[4];
	
	DEBUG(DEBUG_CALLTRACE,"  Download Buffer,Page=%x, Offset=%x, Length=%x\n",
	 Adapter->dlPage,Adapter->dlOffset,Adapter->dlLength);
*/
// Primary Firmware info

	recordBuffer.RecordLen = 5;
    	recordBuffer.RID       = PRIIDENTITY;	
	status = getRecordFrame(Adapter,pRecordBuffer);	
	
	Adapter->PRIVariant       = pRecordBuffer[3];
	Adapter->PRIMajorVersion = pRecordBuffer[4];
	Adapter->PRIMinorVersion = pRecordBuffer[5];
	
	DEBUG(DEBUG_CALLTRACE,"  Primary Firmware ,CompID=%x, Variant=%x, Major=%x, Minor=%x\n",
	    pRecordBuffer[2],pRecordBuffer[3],pRecordBuffer[4],pRecordBuffer[5] );

/*	
	recordBuffer.RecordLen = 6;
    	recordBuffer.RID       = PRISUPRANGE;	
	status = getRecordFrame(Adapter,pRecordBuffer);
	
	DEBUG(DEBUG_CALLTRACE, "  Primary Firmware ,Role=%x, ID=%x, Variant=%x, Bottom=%x,Top=%x\n",
	    pRecordBuffer[2],pRecordBuffer[3],pRecordBuffer[4],pRecordBuffer[5],pRecordBuffer[6]);
*/

// Station Function(Secondary) Firmware
	recordBuffer.RecordLen = 5;
	recordBuffer.RID       = STAIDENTITY;	
	status = getRecordFrame(Adapter,pRecordBuffer);	
	
	Adapter->STAVariant       = pRecordBuffer[3];
	Adapter->STAMajorVersion = pRecordBuffer[4];
	Adapter->STAMinorVersion = pRecordBuffer[5];
	
	DEBUG(DEBUG_CALLTRACE,"  Station Function Firmware ,CompID=%x, Variant=%x, Major=%x, Minor=%x\n",
	    pRecordBuffer[2],pRecordBuffer[3],pRecordBuffer[4],pRecordBuffer[5] );

/*
	recordBuffer.RecordLen = 6;
    	recordBuffer.RID       = STASUPRANGE;	
	status = getRecordFrame(Adapter,pRecordBuffer);
	
	DEBUG(DEBUG_CALLTRACE,"  Station Function Firmware ,Role=%x, ID=%x, Variant=%x, Bottom=%x,Top=%x\n",
	    pRecordBuffer[2],pRecordBuffer[3],pRecordBuffer[4],pRecordBuffer[5],pRecordBuffer[6]);
*/


//Available channel
	recordBuffer.RecordLen = 2;
    	recordBuffer.RID       = CHANNELLIST;	
	status = getRecordFrame(Adapter,pRecordBuffer);
	
	if(status != COMMAND_SUCCESS)
		Adapter->AvailableChannel = 0x1FFF;
	else	
	        Adapter->AvailableChannel = pRecordBuffer[2];
	
	DEBUG(DEBUG_CALLTRACE, "  Available Channel = %x\n", Adapter->AvailableChannel);
	
//Get WEP available.
	recordBuffer.RecordLen = 2;
    	recordBuffer.RID       = PRIVACYOPTIONIMPLEMENTED;	
	status = getRecordFrame(Adapter,pRecordBuffer);
	if(status != COMMAND_SUCCESS)
	   Adapter->AvailableWEP = 0;     // 
	else
	   Adapter->AvailableWEP = pRecordBuffer[2];
	   
	DEBUG(DEBUG_CALLTRACE, "  Available WEP  = %x\n", Adapter->AvailableWEP);
 	

	 return COMMAND_SUCCESS;		
}	

/********************************************************************
 * EOF
 */
